- Cal3D 0.11 API Reference -

Public Member Functions | Protected Member Functions | List of all members
cal3d::TiXmlDocument Class Reference

Always the top level node. More...

`#include <tinyxml.h>`

Inheritance diagram for cal3d::TiXmlDocument:

## Public Member Functions

| TiXmlDocument ()
| Create an empty document, that has no name.
| TiXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml.
| TiXmlDocument (const std::string &documentName)
| Constructor.
bool | LoadFile ()
| Load a file using the current document value.
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful.
bool | LoadFile (const char *filename)
| Load a file using the given filename. Returns true if successful.
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful.
bool | LoadFile (const std::string &filename)
bool | SaveFile (const std::string &filename) const
| < STL std::string version.
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0)
| Parse the given null terminated block of xml data.
TiXmlElement * | RootElement () const
| Get the root element – the only top level element – of the document.
bool | Error () const
| If an error occurs, Error will be set to true.
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs.
const int | ErrorId () const
| Generally, you probably want the error string ( ErrorDesc() ).
int | ErrorRow ()
| Returns the location (if known) of the error.
int | ErrorCol ()
| The column where the error occured. See ErrorRow().
void | SetTabSize (int _tabsize)
| By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded.
int | TabSize () const
void | ClearError ()
| If you have handled the error, it can be reset with this call.
void | Print () const
| Dump the document to standard out.
virtual void | Print (FILE *cfile, int depth=0) const
| All TinyXml classes can print themselves to a filestream.
void | SetError (int err, const char *errorLocation, TiXmlParsingData *prevData)
Public Member Functions inherited from cal3d::TiXmlNode
const char * | Value () const
| The meaning of 'value' changes for the specific type of TiXmlNode.
void | SetValue (const char *_value)
| Changes the value of the node.
void | SetValue (const std::string &_value)
| STL std::string form.
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent () const
| One step up the DOM.
TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. Will be null if none found.
TiXmlNode * | LastChild () const
TiXmlNode * | LastChild (const char *value) const
| The last child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild (const std::string &_value) const
| The last child of this node matching 'value'. Will be null if there are no children.
TiXmlNode * | LastChild (const std::string &_value) const
| STL std::string form.
TiXmlNode * | IterateChildren (TiXmlNode *previous) const
| An alternate way to walk the children of a node.
TiXmlNode * | IterateChildren (const char *value, TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
TiXmlNode * | IterateChildren (const std::string &_value, TiXmlNode *previous) const
| STL std::string form.
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
| Add a new node related to this.
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
| Replace a child of this node.
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | NextSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
TiXmlElement * | NextSiblingElement () const
| Convenience function to get through elements.
TiXmlElement * | NextSiblingElement (const char *) const
| Convenience function to get through elements.
TiXmlElement * | NextSiblingElement (const std::string &_value) const
| STL std::string form.
TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const char *value) const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const std::string &_value) const
| STL std::string form.
virtual int | Type () const
| Query the type (as an enumerated value, above) of this node.
TiXmlDocument * | GetDocument () const
| Return a pointer to the Document this node lives in.
bool | NoChildren () const
| Returns true if this node has no children.
TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlText * | ToText () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null not of the requested type.
void | SetUserData (void *user)
void * | GetUserData ()
Public Member Functions inherited from cal3d::TiXmlBase
int | Row () const
| Return the position, in the original source file, of this node or attribute.
int | Column () const
| See Row().

## Protected Member Functions

virtual void | StreamOut (TIXML_OSTREAM *out) const
virtual TiXmlNode * | Clone () const
virtual void | StreamIn (TIXML_ISTREAM *in, TIXML_STRING *tag)
Protected Member Functions inherited from cal3d::TiXmlNode
| TiXmlNode (NodeType type)
TiXmlNode * | Identify (const char *start)
void | CopyToClone (TiXmlNode *target) const
TIXML_STRING | SValue () const

## Additional Inherited Members

Public Types inherited from cal3d::TiXmlNode
enum | NodeType { DOCUMENT , ELEMENT , COMMENT , UNKNOWN , TEXT , DECLARATION , TYPECOUNT }
| The types of XML nodes supported by TinyXml. More...
Static Public Member Functions inherited from cal3d::TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
| The world does not agree on whether white space should be kept or not.
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.
Protected Types inherited from cal3d::TiXmlBase

enum

{
TIXML_NO_ERROR = 0 , TIXML_ERROR , TIXML_ERROR_OPENING_FILE , TIXML_ERROR_OUT_OF_MEMORY ,
TIXML_ERROR_PARSING_ELEMENT , TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME , TIXML_ERROR_READING_ELEMENT_VALUE , TIXML_ERROR_READING_ATTRIBUTES ,
TIXML_ERROR_PARSING_EMPTY , TIXML_ERROR_READING_END_TAG , TIXML_ERROR_PARSING_UNKNOWN , TIXML_ERROR_PARSING_COMMENT ,
TIXML_ERROR_PARSING_DECLARATION , TIXML_ERROR_DOCUMENT_EMPTY , TIXML_ERROR_STRING_COUNT
}

Static Protected Member Functions inherited from cal3d::TiXmlBase
static const char * | SkipWhiteSpace (const char *)
static bool | IsWhiteSpace (int c)
static bool | StreamWhiteSpace (TIXML_ISTREAM *in, TIXML_STRING *tag)
static bool | StreamTo (TIXML_ISTREAM *in, int character, TIXML_STRING *tag)
static const char * | ReadName (const char *p, TIXML_STRING *name)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase)
static const char * | GetEntity (const char *in, char *value)
static const char * | GetChar (const char *p, char *_value)
static void | PutString (const TIXML_STRING &str, TIXML_OSTREAM *out)
static void | PutString (const TIXML_STRING &str, TIXML_STRING *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase)
Protected Attributes inherited from cal3d::TiXmlNode
TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
void * | userData
Protected Attributes inherited from cal3d::TiXmlBase
TiXmlCursor | location
Static Protected Attributes inherited from cal3d::TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Always the top level node.

A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

## Member Function Documentation

## ◆ ClearError()

void cal3d::TiXmlDocument::ClearError | ( |  | ) |

inline

If you have handled the error, it can be reset with this call.

The error state is automatically cleared if you Parse a new XML block.

## ◆ Clone()

TiXmlNode * cal3d::TiXmlDocument::Clone | ( |  | ) | const

protected virtual

Implements cal3d::TiXmlNode.

## ◆ Error()

bool cal3d::TiXmlDocument::Error | ( |  | ) | const

inline

If an error occurs, Error will be set to true.

Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

## ◆ ErrorId()

const int cal3d::TiXmlDocument::ErrorId | ( |  | ) | const

inline

Generally, you probably want the error string ( ErrorDesc() ).

But if you prefer the ErrorId, this function will fetch it.

## ◆ ErrorRow()

int cal3d::TiXmlDocument::ErrorRow | ( |  | ) |

inline

Returns the location (if known) of the error.

The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See also
  SetTabSize, Row, Column

## ◆ LoadFile() [1/2]

bool cal3d::TiXmlDocument::LoadFile | ( |  | ) |

Load a file using the current document value.

Returns true if successful. Will delete any existing document data before loading.

## ◆ LoadFile() [2/2]

bool cal3d::TiXmlDocument::LoadFile | ( | const std::string & | filename | ) |

inline

Parameters

  filename | STL std::string version.

## ◆ Parse()

const char * cal3d::TiXmlDocument::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = 0 )

virtual

Parse the given null terminated block of xml data.

Implements cal3d::TiXmlBase.

## ◆ Print()

void cal3d::TiXmlDocument::Print | ( | FILE * | cfile,
|  | int | depth = 0 ) const

virtual

All TinyXml classes can print themselves to a filestream.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implements cal3d::TiXmlBase.

## ◆ RootElement()

TiXmlElement * cal3d::TiXmlDocument::RootElement | ( |  | ) | const

inline

Get the root element – the only top level element – of the document.

In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

## ◆ SetTabSize()

void cal3d::TiXmlDocument::SetTabSize | ( | int | _tabsize | ) |

inline

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded.

Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    TiXmlDocument doc;
    doc.SetTabSize( 8 );
    doc.Load( "myfile.xml" );

See also
  Row, Column

## ◆ StreamIn()

void cal3d::TiXmlDocument::StreamIn | ( | TIXML_ISTREAM * | in,
|  | TIXML_STRING * | tag )

protected virtual

Implements cal3d::TiXmlNode.

## ◆ StreamOut()

void cal3d::TiXmlDocument::StreamOut | ( | TIXML_OSTREAM * | out | ) | const

protected virtual

Implements cal3d::TiXmlBase.

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlparser.cpp

Generated by The Cal3D Team with Doxygen 1.15.0